; DF    LO. ,       64
;   OK

.include "tn2313def.inc"   	
.def	RR0	=	r0	;
.def	decr	=	r1	;

.def	OST1=	r7
.def	OST2=	r8
.def	OST3=	r9
.def	A3	=	r14
.def	B3	=	r15
.def	dcnt=	r24
.def	A1	=	r10		;multiplicand low byte
.def	A2	=	r11		;multiplicand high byte
.def	B1	=	r12		;multiplier low byte
.def	B2	=	r13		;multiplier high byte
.def	C1	=	r12		;result byte 0 (LSB)
.def	C2	=	r13		;result byte 1
.def	C3	=	r14		;result byte 2
.def	C4	=	r15		;result byte 3 (MSB)

.def	flags	=	r20
.def	buf		=	r18
.def	per1	=r30
.def	per2	=r31

.def	tsreg	=	r4
.def	delitel	=	r5

.def	df		=	r17	;  df
.def	zn1		=	r21	;
.def	zn2		=	r22	;
; A3:A2:A1/B3:B2:B1=A3:A2:A1  OST3:OST2:OST1
; A2:A1*B2:B1=C4:C3:C2:C1

;------------------
;r20.0 $1  	; 1   tc1
;r20.1 $2	;     
;r20.2 $4  	;     1   
;r20.3 $8  	; bit pin
;r20.4 $10 	; 
;r20.5 $20 	; 
;r20.6 $40	; 
;r20.7 $80 	; 

.cseg	rjmp main	
	reti		;int0
	reti		;int1
	reti		;TC1  
	reti		;TC1    
	rjmp t1	;TC0  
	rjmp t0	;TC1  
	reti		;UART   
	reti		;UART   
	reti		;UART  
	reti		;
	reti		;     
	reti		;TC1   B 
	reti		;TC0   B
	reti		;TC0   A
	reti		;USI   
	reti		;USI 
	reti		;EEPROM 
	reti		;WDT 
	nop
dat:
.db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09
.db $10,$11,$12,$13,$14,$15,$16,$17,$18,$19
.db $20,$21,$22,$23,$24,$25,$26,$27,$28,$29
.db $30,$31,$32,$33,$34,$35,$36,$37,$38,$39
.db $40,$41,$42,$43,$44,$45,$46,$47,$48,$49
.db $50,$51,$52,$53,$54,$55,$56,$57,$58,$59
.db $60,$61,$62,$63,$64,$65,$66,$67,$68,$69
.db $70,$71,$72,$73,$74,$75,$76,$77,$78,$79
.db $80,$81,$82,$83,$84,$85,$86,$87,$88,$89
.db $90,$91,$92,$93,$94,$95,$96,$97,$98,$99

zif:	
	.db $03,$9F,$25,$0D,$99,$49,$41,$1F,$01,$09
;        0   1   2   3   4   5   6   7   8   9   
main:
;  
	ldi R16,$DF		; 
	out SPL,R16
;   D
	ldi r16,0b1111010  	;  PD(0,2)  + . 
	out DDRD,r16
	ldi R16,0B0000101 		
	out portd,r16        	;   c
;   B
	ldi r16,$FF 	;  PB(1-7) 
	out DDRB,r16
;	ldi R16,0B11111110 			
;	out portd,r16        	;   c
;  		 		
	ldi R16,0B10000010 	;  0  1
	out timsk,r16		; 
; timer0		;  
	ldi R16,0B00000100 	;  256
	out tccr0b,r16		;     
; timer1 		;  
;	ldi R16,0B00000001 	;  1 band 1
;	ldi R16,0B00000010 	;  8 band 0
	ldi R16,0B00000000 	; TC 
	out tccr1b,r16		; 
; WDT  2 
	ldi r16,0b00001111
	out wdtcr,r16
;     
	clr flags
	ldi buf,0B00000011
	mov delitel,buf
	ldi buf,100
	mov decr,buf
	sei
;*************************************************************************************
;*************************************************************************************
telo:
	nop
	sbrs flags,2	;    0,5
	rjmp telo
	cbr flags,$4	;  ( )
;*************************** *******************************
;    1-, 0-    PD0
;	sbis pind,0		; 
;	rjmp band_0		;
	tst df
	breq na_lo
	cpi df,$FF
	breq band_0
	rjmp band_good
na_lo:
	ldi buf,0B00000011
	mov delitel,buf
	rjmp band_good
band_0:
; 	   1  0
;   pind0=0     
	ldi buf,0B00000001
	mov delitel,buf
band_good:
;*************************     ************************
	clr df
;     
no_zero:	
	sbic pinD,2
	rjmp no_zero
;   tcnt1
	clr buf
	out tccr1b,buf	;  1	
	NOP
	out tcnt1h,buf
	out tcnt1l,buf
;  
no_front:
	sbis pinD,2	
	rjmp no_front
	out tccr1b,delitel		;     TC1	
;      -  
nosp1:
	sbic pinD,2	
	rjmp nosp1
;  
no_front2:
	sbis pinD,2	
	rjmp no_front2
;     1
	clr buf			 	; TC 
	out tccr1b,buf		; 
;  tcnt1       dd16uH dd16uL
	in per1, tcnt1l
	in per2, tcnt1h	;  
;*****************************************************************
;    1    DF -> 'Lo'   ind 
	sbrc flags,0
	rjmp bilo_perep
;       per2:per1 <200
	tst per2
	brne ok1
	cpi per1,200
	brsh ok1
	ser df
;   
	rjmp telo
bilo_perep:
	cbr flags,$1		;    
	clr df
	rjmp telo
ok1:
;**********************************    *****************
;     
no_zero2:	
	sbic pinD,2
	rjmp no_zero2
;   tcnt1
	clr buf
	out tccr1b,buf		;  1	
	NOP
	out tcnt1h,buf
	out tcnt1l,buf
;  
no_front3:
	sbis pinD,2	
	rjmp no_front3
;     TC1	
	out tccr1b,delitel		;
;    -   
nosp:
	sbic pinD,2	
	rjmp nosp
;    1
	clr buf 			; TC 
	out tccr1b,buf		; 
;  tcnt1       dd16uH dd16uL
	in A1, tcnt1l
	in A2, tcnt1h	;   
;     100
	ldi buf,100
	clr b2
	mov b1,buf
	rcall	mpy16u
; A3:A2:A1/B3:B2:B1=A3:A2:A1  OST3:OST2:OST1
; A2:A1*B2:B1=C4:C3:C2:C1
; 
	clr c4  ; a3   c3
	mov a1,c1
	mov a2,c2
;  
	clr b3
	mov b1,per1
	mov b2,per2
;  
	rcall div16u
	ldi df,100
	sub df,a1
;    DF  DF<100 
	cpi df,100
	brlo ind
	clr df
	rjmp telo
ind:
;  ind      -  df  'Hi'
;         'Lo'   

;*************************     ************
;       
	ldi	zh,High(2*DAT)	; FreqIndex = Lo ProgramTab[Step]
	ldi	zl,Low(2*DAT)	; FreqDelay = Hi ProgramTab[Step]
	add zl,df			; 
	lpm					;   
	mov zn1,r0
	andi zn1,$0f		;     znak1
	mov zn2,r0
	andi zn2,$f0		
	swap zn2			;     znak2
;      
	ldi	zh,High(2*zif)	; FreqIndex = Lo ProgramTab[Step]
	ldi	zl,Low(2*zif)	; FreqDelay = Hi ProgramTab[Step]
	push zl
	add zl,zn1
	lpm
	mov zn1,r0			;    zn1
	pop zl
	add zl,zn2	
	lpm
	mov zn2,r0			;    zn2
	rjmp telo
;****************************************************************************************

t0:
	in tsreg,sreg
	wdr
	dec decr		;       0,5 
	brne j1
	ldi buf,100
	mov decr,buf	
	sbr flags,$4	; 
;  DF  df=0 'Lo' DF=$FF 'Hi'     
	tst df
	breq lo
	cpi df,$FF
	breq hi
	rjmp j1
hi:		
	ldi zn1,$F7		;   i
	ldi zn2,$90		;   H
	rjmp j1	
lo:
	ldi zn1,$C5		;   o
	ldi zn2,$E3		;   L
	
j1:
	sbrs flags,1
	rjmp one
	cbr flags,$2
;     
	cbi portd,5
	nop
	sbi portd,6
	nop
	out portb,zn1
	out sreg,tsreg
	reti	
one:
	sbr flags,$2
;     
	cbi portd,6
	nop
	sbi portd,5
	nop
	out portb,zn2
	out sreg,tsreg
	reti

;****************************************************
;            
t1:
	in tsreg,sreg
;    
	sbr flags,$1
	out sreg,tsreg
	reti	
;***********************************************************************
;*******************************************************
;*******************************************************
; A3:A2:A1/B3:B2:B1=A3:A2:A1  OST3:OST2:OST1
div16u:
	clr	OST1		;clear remainder Low byte
	sub	OST3,OST3	;clear remainder High byte and carry
	sub	OST2,OST2	;clear remainder High byte and carry
	ldi	dcnt,25		;init loop counter

d16u_1:
	rol	A1			;shift left dividend
	rol	A2
	rol	A3
	dec	dcnt			;decrement counter
	brne	d16u_2			;if done
	ret				;    return
d16u_2:	
	rol	OST1		;shift dividend into remainder
	rol	OST2
	rol	OST3

	sub	OST1,B1		;remainder = remainder - divisor
	sbc	OST2,B2		;
	sbc	OST3,B3	;

	brcc	d16u_3			;if result negative
	add	OST1,B1		;    restore remainder
	adc	OST2,B2
	adc	OST3,B3

	clc				;    clear carry to be shifted into result
	rjmp	d16u_1			;else
d16u_3:	sec				;    set carry to be shifted into result
	rjmp	d16u_1
;************************************************************
; A2:A1*B2:B1=C4:C3:C2:C1
mpy16u:	clr	C4		;clear 2 highest bytes of result
	clr	C3
	ldi	dcnt,16	;init loop counter
	lsr	B2
	ror	B1

m16u_1:	brcc	noad8		;if bit 0 of multiplier set
	add	C3,A1	;add multiplicand Low to byte 2 of res
	adc	C4,A2	;add multiplicand high to byte 3 of res
noad8:	ror	C4		;shift right result byte 3
	ror	C3		;rotate right result byte 2
	ror	C2		;rotate result byte 1 and multiplier High
	ror	C1		;rotate result byte 0 and multiplier Low
	dec	dcnt		;decrement loop counter
	brne	m16u_1		;if not done, loop more
	ret
	.exit
  
